﻿<!DOCTYPE html>
<html>

<head>
    <meta charset=utf-8>
    <title>Fireball prototype</title>
    <style>
        body {
            margin: 0;
            overflow: hidden;
        }

        canvas {
            width: 100%;
            height: 100%
        }
    </style>
</head>

<body>
<script src="js/Three.js"></script>

<script src="js/OrbitControls.js"></script>
<script>


    // Init
    var scene = new THREE.Scene();
    var camera = new THREE.PerspectiveCamera(60, window.innerWidth / window.innerHeight, 0.1, 1000);
    var renderer = new THREE.WebGLRenderer({
        antialias: true
    });

    var controls = new THREE.OrbitControls(camera, renderer.domElement);

    var textureLoader = new THREE.TextureLoader();
    var earthTexture = textureLoader.load("textures/earth.jpg");
    var fireballTexture = textureLoader.load("textures/fireball.jpg");
    var earthCloudTexture = textureLoader.load("textures/earthcloud.jpg");

    // Skybox
    var path = "textures/";
    var name = 'cosmos.png';
    var urls = [
        path + name,
        path + name,
        path + name,
        path + name,
        path + name,
        path + name
    ];

    var reflectionCube = THREE.ImageUtils.loadTextureCube(urls);
    reflectionCube.format = THREE.RGBFormat;

    var reflectionCubeShader = THREE.ShaderLib["cube"];
    reflectionCubeShader.uniforms["tCube"].value = reflectionCube;

    var reflectionCubeMaterial = new THREE.ShaderMaterial({
        fragmentShader: reflectionCubeShader.fragmentShader,
        vertexShader: reflectionCubeShader.vertexShader,
        uniforms: reflectionCubeShader.uniforms,
        depthWrite: false,
        side: THREE.BackSide
    });

    reflectionCubeMesh = new THREE.Mesh(new THREE.BoxGeometry(150, 150, 150), reflectionCubeMaterial);
    scene.add(reflectionCubeMesh);

    scene.background = new THREE.Color(0, 0, 0);
    renderer.setSize(window.innerWidth, window.innerHeight);
    document.body.appendChild(renderer.domElement);

    // Fireball
    var fireball = new THREE.Mesh(new THREE.SphereGeometry(0.35, 32, 32), new THREE.MeshBasicMaterial({
        color: 0xffffff,
        metalness: 0,
        map: fireballTexture

    }));
    let axesHelper = new THREE.AxesHelper(5);
    fireball.add(axesHelper);

    // Earth
    var earthGeom = new THREE.SphereGeometry(1.5, 32, 32);
    var earthMaterial = new THREE.MeshBasicMaterial({
        color: 0xffffff,
        metalness: 0,
        map: earthTexture
    });
    var earth = new THREE.Mesh(earthGeom, earthMaterial);
    let axesHelper1 = new THREE.AxesHelper(5);
    earth.add(axesHelper1);

    // Earth cloud
    var earthCloudGeom = new THREE.SphereGeometry(1.51, 32, 32);
    var earthCloudMaterial = new THREE.MeshBasicMaterial({
        color: 0xffffff,
        metalness: 0,
        alphaMap: earthCloudTexture,
        transparent: true
    });
    var earthCloud = new THREE.Mesh(earthCloudGeom, earthCloudMaterial);

    // Group
    var earthGroup = new THREE.Group();
    earthGroup.add(earth);
    earthGroup.add(earthCloud);
    scene.add(earthGroup);

    var fireballGroup = new THREE.Group();
    fireballGroup.add(fireball);
    earthGroup.add(fireballGroup);

    fireball.lookAt(earth.position);

    scene.add(earth);

    // Position camera
    camera.position.z = 10;

    // Vitesse astre
    earthSpeed = 0.0008;
    earthCloudSpeed = earthSpeed * 2;
    fireballSpeed = 0.0005; // realistic fireball speed = earth speed / 27

    fireballPosition = 8;

    var interval = setInterval(flashText, 2000);

    var geometry = new THREE.CircleGeometry(8, 32);
    var material = new THREE.MeshBasicMaterial({color: 0xffff00});
    var circle = new THREE.Mesh(geometry, material);


    material.side = THREE.DoubleSide;
    scene.add(circle);
    var raycaster = new THREE.Raycaster(),
        mouse = new THREE.Vector2(),
        intersects;
    renderer.domElement.addEventListener('click', searchTarget, false);

    function searchTarget(event)
    {
        console.log("J'ai cliqué")
        mouse.x = (event.clientX / window.innerWidth) * 2 - 1;
        mouse.y = -(event.clientY / window.innerHeight) * 2 + 1;
        console.log("X --> ",mouse.x)
        console.log("Y --> ",mouse.y)
        raycaster.setFromCamera(mouse, camera);
        intersects = raycaster.intersectObjects(fireballGroup.children);
        console.log(intersects)
        if (intersects.length > 0) {
            console.log("J'ai un putain d'objet")
            fireballGroup.remove( intersects[0].object );
            console.log(intersects[0])

        }
    }


    function flashText() {
        // let positionX= Math.random() * (800 - (-800)) -800;
        // positionX=positionX/100
        // console.log("position X",positionX)
        // let alpha=Math.acos(positionX/8)
        // console.log("Alpha",alpha)
        // let positionY=8*Math.sin(alpha)
        // console.log("positionY",positionY)
        //let positionY=Math.random() * (8 - 0) +0;
        let newFireball = new THREE.Mesh(new THREE.SphereGeometry(0.35, 32, 32), new THREE.MeshBasicMaterial({
            color: 0xffffff,
            metalness: 0,
            map: fireballTexture

        }));


        let coefY = (Math.random() * (200 - 0) + 0) / 100
        let coefZ = (Math.random() * (200 - 0) + 0) / 100

        newFireball.rotateY(coefY * Math.PI);
        newFireball.rotateZ(coefZ * Math.PI);

        newFireball.translateX(8);
        fireballGroup.add(newFireball)
        // newFireball.translateX(positionX);
        // newFireball.translateY(random_boolean?positionY:-positionY);


    }


    // Animate scene
    var animate = function () {
        earth.rotateY(earthSpeed);
        earthCloud.rotateY(earthCloudSpeed);
        //console.log("fireballGroup Size",fireballGroup.children)
        fireball.rotateX(fireballSpeed);
        fireball.rotateY(fireballSpeed);
        fireball.position.set(0, 0, 0);
        fireball.translateX(fireballPosition);
        requestAnimationFrame(animate);
        renderer.render(scene, camera);

    };
    animate();

    /*function MoveFireball(fireball)
    {
        fireball.translateX(fireballPosition - 1);
        setTimeout(MoveFireball(fireball), 1000);
    }
    MoveFireball(fireball);*/
</script>
</body>

</html>
